$COM 0
$COMPILE UNIT "WINLIB.PBU"
$CPU 8086
$DEBUG MAP OFF
$DIM ALL
$ERROR ALL OFF
$EVENT OFF
$FLOAT EMULATE
$LIB ALL OFF
$OPTIMIZE SIZE
$OPTION CNTLBREAK OFF
$SOUND 1
$STACK 2048
$STRING 1

$IF 0
 The Surealsoft Windows 95 Library for dos boxes.
 Written by Reinier Zwitserloot.
 Source code Copyright (C) 1997 by Reinier Zwitserloot.
 All Rights reserved.

 Please see the accompanying PB help file.
 Copy WINLIB.PBH into your PB root directory and hit SHIFT+F1 until
 the WINLIB help file appears.

$ENDIF

DECLARE FUNCTION SFN (FileN AS STRING, PthO AS BYTE) AS STRING
DECLARE FUNCTION LFN (FileN AS STRING, PthO AS BYTE) AS STRING
DECLARE FUNCTION Win95L () AS BYTE
DECLARE FUNCTION GetSYSREG () AS STRING
DECLARE SUB SetSYSREG (NewLoc AS STRING)
DECLARE SUB SETCRITICAL (Flag AS BYTE)
DECLARE FUNCTION VMNumber () AS WORD
DECLARE SUB FullScreen ()
DECLARE SUB SetFocus(ATmp1 AS WORD)
DECLARE SUB SetTitle(TheName AS STRING, Flag AS BYTE)
DECLARE SUB LFNMakeDir (DirName AS STRING)
DECLARE SUB LFNRename (OrigName AS STRING, NewName AS STRING)

SUB LFNRename (OrigName AS STRING, NewName AS STRING) LOCAL PUBLIC
DIM Tmp1 AS STRING *500
DIM Tmp2 AS STRING *500
DIM ATmp1 AS WORD
DIM ATmp2 AS WORD
DIM ATmp3 AS WORD
DIM ATmp4 AS WORD
IF LEN (OrigName)>499 OR LEN(NewName)>499 THEN EXIT SUB
Tmp1=OrigName+STRING$(500-LEN(OrigName),CHR$(0))
Tmp2=NewName+STRING$(500-LEN(NewName),CHR$(0))
ATmp1=VARSEG(Tmp1)
ATmp2=VARSEG(Tmp2)
ATmp3=VARPTR(Tmp1)
ATmp4=VARPTR(Tmp2)

!MOV AX, ATmp1
!MOV DS, AX
!MOV AX, ATmp2
!MOV ES, AX
!MOV DX, ATmp3
!MOV DI, ATmp4
!MOV AX, &h7156
!INT &h21
END SUB

SUB LFNMakeDir (DirName AS STRING) LOCAL PUBLIC
DIM Tmp AS STRING *500
DIM ATmp1 AS WORD
DIM ATmp2 AS WORD
IF LEN(DirName)>499 THEN EXIT SUB
Tmp=DirName+STRING$(500-LEN(DirName),CHR$(0))
ATmp1=VARSEG(Tmp)
ATmp2=VARPTR(Tmp)

!MOV AX, ATmp1
!MOV DX, AX
!MOV DX, ATmp2
!MOV AX, &h7139
!INT &h21
END SUB

SUB SetTitle(TheName AS STRING, Flag AS BYTE) LOCAL PUBLIC
DIM Tmp AS STRING *80
DIM ATmp1 AS WORD
DIM ATmp2 AS WORD
DIM ATmp3 AS WORD

IF LEN(TheName)>79 THEN EXIT SUB
IF LEN(TheName)>29 AND Flag>0 THEN EXIT SUB
Tmp=TheName+STRING$(80-LEN(TheName),CHR$(0))
ATmp1=VARSEG(Tmp)
ATmp2=VARPTR(Tmp)
IF Flag=0 THEN ATmp3=0 ELSE ATmp3=1

!MOV AX, ATmp1
!MOV ES, AX
!MOV DI, ATmp2
!MOV AX, &h168E
!MOV DX, ATmp3
!INT &h2F
END SUB



SUB FullScreen () LOCAL PUBLIC
!MOV AX, &h168B
!XOR BX, BX
!INT &h2F
END SUB

SUB SetFocus (ATmp1 AS WORD) LOCAL PUBLIC
DIM ATmp2 AS WORD
ATmp2=ATmp1
!MOV AX, &h168B
!MOV BX, ATmp2
!INT &h2F
END SUB

FUNCTION VMNumber () LOCAL PUBLIC AS WORD
DIM ATmp1 AS WORD
!MOV AX, &h1683
!INT &h2F
!MOV ATmp1, BX
FUNCTION = ATmp1
END FUNCTION

SUB SetCritical (Flag AS BYTE) LOCAL PUBLIC
IF Flag=0 THEN
!MOV AX, &h1681
!INT &h2F
ELSE
!MOV AX, &h1682
!INT &h2F
END IF
END SUB

SUB SetSYSREG (NewLoc AS STRING) LOCAL PUBLIC
DIM TmpBuf1 AS STRING*78
DIM ATmp1 AS WORD
DIM ATmp2 AS WORD
IF LEN(NewLoc)>78 THEN EXIT SUB
ATmp1=VARSEG(TmpBuf1)
ATmp2=VARPTR(TmpBuf1)
TmpBuf1=NewLoc+STRING$(78-LEN(NewLoc),CHR$(0))
!MOV AX, ATmp1
!MOV ES, AX
!MOV DI, ATmp2
!MOV AX, &h1614
!INT &h2F
END SUB

FUNCTION GetSYSREG () LOCAL PUBLIC AS STRING
DIM TmpBuf1 AS STRING*78
DIM LenTmp AS WORD
DIM ATmp1 AS WORD
DIM ATmp2 AS WORD
ATmp1=VARSEG(TmpBuf1)
ATmp2=VARPTR(TmpBuf1)
!MOV AX, ATmp1
!MOV ES, AX
!MOV DI, ATmp2
!MOV CX, 78
!MOV AX, &h1613
!INT &h2F
!OR AX, AX
!JNZ GetSYSREGns
!MOV LenTmp, CX

FUNCTION=RTRIM$(LEFT$(TmpBuf1,LenTmp),ANY CHR$(00,32))
EXIT FUNCTION
GetSYSREGns:
FUNCTION="*error*"
END FUNCTION


FUNCTION LFN (FileN AS STRING, PthO AS BYTE) PUBLIC LOCAL AS STRING
DIM TmpBuf1 AS STRING*67
DIM TmpBuf2 AS STRING*261
DIM TmpST AS STRING
IF LEN(FileN)>66 THEN FUNCTION="*Error*":EXIT FUNCTION
TmpBuf1 = FileN+CHR$(0)

REG 1, &h7160
IF BIT(PthO,0)=1 THEN REG 3,2 ELSE REG 3, &h8002
REG 5, VARPTR (TmpBuf1)
REG 6, VARPTR (TmpBuf2)
REG 8, VARSEG (TmpBuf1)
REG 9, VARSEG (TmpBuf2)
CALL INTERRUPT &h21
TmpST = RTRIM$(TmpBuf2,ANY CHR$(32,0))
IF BIT(PthO,1)=1 THEN
 WHILE INSTR(TmpST, "\")<>0
 TmpST = MID$(TmpST, INSTR(TmpST,"\")+1)
 WEND
END IF
FUNCTION = TmpST
END FUNCTION

FUNCTION SFN (FileN AS STRING, PthO AS BYTE) PUBLIC LOCAL AS STRING
DIM TmpBuf1 AS STRING*261
DIM TmpBuf2 AS STRING*67
DIM TmpST AS STRING
IF LEN(FileN)>260 THEN FUNCTION="*Error*":EXIT FUNCTION
TmpBuf1 = FileN+CHR$(0)

REG 1, &h7160
IF BIT(PthO,0)=1 THEN REG 3, 1 ELSE REG 3, &h8001
REG 5, VARPTR (TmpBuf1)
REG 6, VARPTR (TmpBuf2)
REG 8, VARSEG (TmpBuf1)
REG 9, VARSEG (TmpBuf2)
CALL INTERRUPT &h21
TmpST = RTRIM$(TmpBuf2,ANY CHR$(32,0))
IF BIT(PthO,1)=1 THEN
 WHILE INSTR(TmpST, "\")<>0
 TmpST = MID$(TmpST, INSTR(TmpST,"\")+1)
 WEND
END IF
FUNCTION = TmpST
END FUNCTION

FUNCTION Win95L () LOCAL PUBLIC AS BYTE
 !MOV AX, &h1600
 !INT &h2F
 !CMP AL, 4
 !JNZ Win95L_NotInWindows

Win95L = 255
EXIT FUNCTION
Win95L_NotInWindows:
Win95L = 0
END FUNCTION
